document.addEventListener('wheel', function(e) {
    e.preventDefault();
    e.stopPropagation();
    var scale;
    var tx;
    var ty;

    if (e.ctrlKey) {
        var s = Math.exp(-e.deltaY / 100);
        scale *= s;
    } else {
        var direction = 1;
        tx += e.deltaX * direction;
        ty += e.deltaY * direction;
    }
    var transform = 'translate(' + tx + 'px, ' + ty + 'px) scale(' + scale + ')';
    var box = 0;
    var style = 0;

}, {
    passive: false
});

$('<div class="quantity-nav"><div class="quantity-button quantity-up">+</div><div class="quantity-button quantity-down">-</div></div>').insertAfter('input[type="number"]');
$('td').each(function() {
    var spinner = $(this),
        input = spinner.find('input[type="number"]'),
        btnUp = spinner.find('.quantity-up'),
        btnDown = spinner.find('.quantity-down'),
        min = input.attr('min'),
        max = input.attr('max');

    btnUp.click(function() {
        var oldValue = parseFloat(input.val());
        if (oldValue >= max) {
            var newVal = oldValue;
        } else {
            var newVal = oldValue + 1;
        }
        spinner.find("input[type='number']").val(newVal);
        spinner.find("input[type='number']").trigger("change");
    });

    btnDown.click(function() {
        var oldValue = parseFloat(input.val());
        if (oldValue <= min) {
            var newVal = oldValue;
        } else {
            var newVal = oldValue - 1;
        }
        spinner.find("input[type='number']").val(newVal);
        spinner.find("input[type='number']").trigger("change");
    });

});


$(".section-bottom div:eq(0)").append("<div class='app-container'><footer><div class='outline'><div class='outline-header' id='outline-header'></div><div class='outline-scroll-container' id='outline-scroll-container' onwheel='outlineMouseWheel(arguments[0])'><div class='outline-items' id='outline-container'></div></div></div><div id='timeline'></div></footer></div>");

var outlineContainer = document.getElementById('outline-container');

let rows = [

    {
        keyframes: [{}],
    },
];

var timeline = new timelineModule.Timeline();
timeline.initialize({ id: 'timeline', headerHeight: 45 });

timeline.setModel({ rows: rows });

$(".overlay #files+label").after('<section class="image-select" data-droppable=""> <input id="image" type="file" data-droppable-input=""/> <i class="fa fa-camera fa-2x image-select__icon"></i> <div class="image-select__message"></div><div class="bg-image aspect-square"')




function loadSVG() {
    var url = 'animations.svg';
    window.open(url, 'Download');
}

if ($(".howToStart").is(":visible")) {
    $(".123").hide()
}

$(".section-left").prepend("<h1><div class='uiButton icon'><i class='material-symbols-rounded'>view_list</i></div><span>Elements</span><div class='uiButton' style='float: right;'><i class='material-symbols-rounded' title='Close window'>close</i></div><div class='uiButton hidden' style='float: right;'></div></h1>");

$(window).on("load", function() {


    $(".inputs, .footer:first(), .AnimationSettings").hide();

    if ($(".section-right .keyframes").is(":visible")) {
        $(".section-right .inputs").show();
    } else {
        $(".section-right .window:eq(0) div:eq(0)").append("<p class='howToStart'>Select an element in the left panel then click on the ANIMATE button</p>")
    };

});


root.prototype.select = function(target) {
    if (!target) {
        target = this.selected.getAttribute('id') || this.selected;
    }
    if (typeof target === 'string') {
        target = document.getElementById(target);

    }
    if (target == null || target.isInsensitive()) { return; }

    popup.hide();
    overlay.hide();

    var clear = target != this.selected;
    this.selected = target;
    this.selected.generateId();

    if (!target.shepherd) {
        if (target.getAttribute('svgooo:type') == 'animationGroup') { new animationGroup(target); }
        if (target.getAttribute('svgooo:type') == 'animatedViewbox') { new animatedViewbox(target); }
    }

    if (target instanceof SVGAnimationElement || target.shepherd && target.shepherd instanceof SVGAnimationElement) {
        svgoooManager.classes.windowAnimation.refresh(clear);
        $(".inputs, .footer:first(), .AnimationSettings").show();
        $(".howToStart").hide();
    }

    svgoooManager.classes.selection.refresh();
    svgoooManager.classes.context.refresh();
    svgoooManager.classes.windowLayers.refresh();

    svgoooManager.classes.menu.refresh();
    svgoooManager.classes.tree.select(target);

    this.ui.edit(target);
    this.ui.putOnTop();

}


$(".popup").on("click", function() {
    $('select option[value="d"]').text("Path (Morphing)");
    $('select option[value="display"]').text("Display");
    $('select option[value="visibility"]').text("Visibility");
    $('select option[value="opacity"]').text("Opacity");
    $('select option[value="filter"]').text("Filter");
    $('select option[value="fill"]').text("Fill color");
    $('select option[value="fill-opacity"]').text("Fill opacity");
    $('select option[value="stroke"]').text("Stroke color");
    $('select option[value="stroke-width"]').text("Stroke width");
    $('select option[value="stroke-opacity"]').text("Stroke opacity");
    $('select option[value="stroke-dasharray"]').text("Stroke dashes");
    $('select option[value="stroke-dashoffset"]').text("Stroke offset");
});

svgoooManager.setCursor('url(_cursors/group.png)');

timeline.onDragFinished(function(obj) {

    let selectedRowIndex = -1;

    rows.forEach((row, index) => {
        if (row.keyframes.some((keyframe) => keyframe.selected)) {
            selectedRowIndex = index;
            return;
        }
    });

    var namesTable = [];
    var valuesTable = [];
    var comboTable = [];
    var comboTable2 = [];
    var comboTable3 = [];
    var durationTable = [];
    var durationTemp = [];
    var durationsOk = [];
    var keytimesOk = [];

    let product = 1;

    for (var i = 0; i < rows.length; i++) {

        titles = rows[i].title;
        namesTable.push(titles);

        comboTable2.push(titles);

        var indexval = rows[i].keyframes.length;

        comboTable3 = new Array(rows[i].title);

        for (var j = 0; j < rows[i].keyframes.length; j++) {
            var testzz = rows[i].keyframes[j].val;
            comboTable3.push(testzz);
        };

        durationTable = comboTable3.filter(Number).slice(-1);
        durationTovalue = durationTable.map(x => (x / 1000) + "s");

        durationsOk.push(durationTovalue[0]);

        comboTable3 = comboTable3.filter(Number);
        merged = [].concat.apply([], comboTable3);
        tovalue = merged.map(x => x / durationTable);
        tovalue.unshift(0);
        tovaluez = [tovalue.join('; ').toString()];

        keytimesOk.push(tovaluez[0]);

        var arrayNamez = rows[i].title;

        arrayName = new Array();
        arrayName.push(tovalue);
    };

    $('.uiSection svg animate, .uiSection svg animateTransform, .uiSection svg animateMotion').each(function(index) {
        $(this).attr("dur", durationsOk[index]);
    });
    $('.uiSection svg animate, .uiSection svg animateTransform, .uiSection svg animateMotion').each(function(index) {
        $(this).attr("keyTimes", keytimesOk[index]);
    });

    $('body div.outline-node:nth-child(' + (parseInt(selectedRowIndex + 1)) + ')').trigger('click');


    var anim = svgoooManager.classes.windowAnimation.animation;
    var newDur = parseFloat(svg.selected.attributes.dur.value.slice(0, -1));
    anim.dur.value = newDur;
    const dur = anim.dur.value * 1000;
    const keyframes = rows[selectedRowIndex].keyframes;

    for (let i = 0; i < keyframes.length; i++) {
        const time = parseFloat(keyframes[i].val) / dur;
        svgoooManager.classes.windowAnimation.setTime(i, time);
    }



    updateTree();
    $('.outline-node').removeClass("selected");
    $('.outline-node:nth-child(' + parseInt(selectedRowIndex + 1) + ')').addClass("selected");

});




function initTimeline() {

    $('.uiSection svg animate, .uiSection svg animateTransform, .uiSection svg animateMotion').each(function() {

        elementID = $(this).attr('id');
        elementParentID = $(this).parent().attr('id');
        animationType = $(this).attr('type');
        animationName = " - " + $(this).attr('attributeName');


        animationMoveThroughPath = $(this).attr('path');
        if (typeof animationType == "undefined") {
            animationType = "";
        } else {
            animationType = " - " + $(this).attr('type');
        }


        if (animationName == " - transform") {
            animationName = ""
        }

        animationID = $(this).parent().attr('id');

        durationsBase = $(this).attr('dur');
        durations = parseFloat(durationsBase.slice(0, -1)) * 1000;

        beginsBase = $(this).attr('begin');
        begins = parseFloat(beginsBase.slice(0, -1)) * 1000;

        valuesBase = $(this).attr('keyTimes').split(";");

        values = valuesBase.map(x => x * durations);

        totalDuration = begins + durations;
        let keyframes = [];
        for (let i = 0; i < values.length; i++) {
            keyframes.push({ val: values[i] });
        }

        rows.push({
            title: elementParentID + animationName + animationType + " " + elementID,
            keyframes: keyframes,
        });

        timeline.setModel({ rows: rows });

        $(".outline-node").remove();
        outlineNodes();

    });

    $('.outline-node').html(function(_, existing) {
        words = existing.trim().split(' ');
        words[0] = '<span class="firstword">' + words[0] + '</span>';
        if (words[0] == '<span class="firstword"><span</span>') {
            resetTimeline();
        }
        words[words.length - 1] = '<span class="lastword">' + words[words.length - 1] + '</span>';
        return words.join('');
    });

};





function resetTimeline() {

    let rows = [{
        keyframes: [{ title: 'No animation', }]
    }];
    timeline.setModel({ rows: rows });
    $(".outline-node").remove();

};







function outlineNodeClickHandler() {



    contenttest = $(this).find('.lastword').text();
    var animationKT = $('.uiSection svg #' + contenttest + '').attr('id');
    var animationParent = $('.uiSection svg #' + contenttest + '').parent().attr('id');
    svg.select(contenttest);
    svgoooManager.classes.windowAnimation.setHeading(animationParent + animationType);
    selectedAnim = $('.outline-node span.lastword:contains(' + contenttest + ')');
    updateTree();
    $('.outline-node').removeClass("selected");
    selectedAnim.parent().addClass("selected");

}

$('body').on('click', 'div.outline-node', outlineNodeClickHandler);

currentTime = 0;

timeline.onTimeChanged(function(event) {
    currentTime = event.val / 1000;
    svg.gotoTime(currentTime);
});

function setTimeline() {
    rows = [];
    initTimeline()
};


document.addEventListener('keydown', function(args) {
    if (args.which === 65 && timeline._controlKeyPressed(args)) {
        timeline.selectAllKeyframes();
        args.preventDefault();
    }
});

timeline.onScroll(function(obj) {
    var options = timeline.getOptions();
    if (options) {
        if (outlineContainer) {
            outlineContainer.style.minHeight = obj.scrollHeight + 'px';
            document.getElementById('outline-scroll-container').scrollTop = obj.scrollTop;
        }
    }
});

function outlineNodes() {

    var options = timeline.getOptions();
    var headerElement = document.getElementById('outline-header');
    headerElement.style.maxHeight = headerElement.style.minHeight = options.headerHeight + 'px';

    rows.forEach(function(row, index) {
        var div = document.createElement('div');
        div.classList.add('outline-node');
        div.style.maxHeight = div.style.minHeight = (row.height || options.rowsStyle.height) + 'px';
        div.style.marginBottom = options.rowsStyle.marginBottom + 'px';
        div.innerText = row.title || 'Track ' + index;
        outlineContainer.appendChild(div);

    });
};

function selectMode() {
    if (timeline) {
        timeline.setInteractionMode('selector');
    }
}

function zoomMode() {
    if (timeline) {
        timeline.setInteractionMode('zoom');
    }
}

function panMode() {
    if (timeline) {
        timeline.setInteractionMode('pan');
    }
}

function outlineMouseWheel(event) {
    if (timeline) {
        this.timeline._handleWheelEvent(event);
    }
}

$(document).ready(function() {

    var cssFilename = localStorage.getItem('cssFilename');
    if (cssFilename) {
        $('link[href="_css/theme1.css"]').attr('href', cssFilename);
    } else {
        $('link[href="_css/theme2.css"]').attr('href', cssFilename);
    }

    $('.section-top-row3').click(function() {
        $('link[href="_css/theme1.css"]').attr('href', '_css/theme2.css');
        localStorage.setItem('cssFilename', '_css/theme2.css');
    });

    $('.section-top-row1').click(function() {
        $('link[href="_css/theme2.css"]').attr('href', '_css/theme1.css');
        localStorage.setItem('cssFilename', '_css/theme1.css');

        updateTree();
    });

    $("#keepTimes").prop("checked", true);
    setTimeline();

});


$('.section-left > *').click(function() {
    updateTree()
});

function updateTree() {
    selected = svg.selected.attributes.id.value;
    isAnimation = "animate";
    animParentId = null;

    $.expr[':'].textEquals = $.expr.createPseudo(function(arg) {
        return function(elem) {
            return $(elem).text().match("^" + arg + "$");
        };
    });

    $('.tree li').find(".material-symbols-rounded:contains('theaters')").parent().parent().css("display", "none");
    $('.tree li').find(".material-symbols-rounded:contains('code_blocks')").parent().parent().css("display", "none");
    $('.tree li').find('.material-symbols-rounded[title="Condense"]:visible').parent().next().children().text("folder_open");
    $('.tree li').find('.material-symbols-rounded[title="Condense"]:not(:visible)').parent().next().children().text("folder");

    $('.tree li').removeClass("selected");
    $('.tree ul').removeClass("selected");
    $('.outline-node').removeClass("selected");
    $('.outline-node').removeClass("matched");
    $(".section-top-row3").find('.material-symbols-rounded[title="Animate element..."]').parent().removeClass("disabled");
    $(".menu").find("button:contains('Animation')").removeClass("disabled");
    setTimeout(
        function() {
            $('.outline-node').find(".lastword:contains('" + selected + "')").parent().addClass("selected");
        }, 20);

    $('.tree li').removeClass("matched");



    if (selected.indexOf(isAnimation) != -1) {
        var selectedId = svg.selected.attributes.id.value;
        var selectedLi = $(this).find("span").filter(function() { return $(this).text() === selectedId; }).parent()
        selectedLi.addClass("selected");
        $(".section-top-row3").find('.material-symbols-rounded[title="Animate element..."]').parent().addClass("disabled");
        $(".menu").find("button:contains('Animation')").addClass("disabled");
        $('.outline-node').find(".lastword:contains('" + selected + "')").parent().addClass("selected");
        $('.tree li').find("span:contains('" + selected + "')").parent().parent().parent().addClass("matched");


    } else {
        $('.tree li').find("span:contains('" + selected + "')").parent().addClass("selected");
        $('ul.tree li.checked > ul').removeClass("selected");
        $('ul.tree li.checked > li').removeClass("selected");
        setTimeout(
            function() {
                $('.outline-node').find(".firstword:contains('" + selected + "')").parent().addClass("matched");
            }, 20);

    }

    $('.outline-node').find(".lastword:contains('" + selected + "')").parent().addClass("selected");

}




$('body').on('click', '.addKeyframe', addKeyFrame);


function addKeyFrame() {
    $('div.outline-node:eq(0)').text();

    setKeyFrameTime()
};

function setKeyFrameTime() {

    keyFrameLength = $('.keyframes > tr').length - 2;
    currentDur = svgoooManager.classes.windowAnimation.animation.dur.value
    keyFrameValue = 0;

    if (currentTime < currentDur) {
        svgoooManager.classes.windowAnimation.contextMenuEvaluate("duplicate", 0);
        keyFrameValue = (parseFloat(currentTime / currentDur) * 100) / 100;
        svgoooManager.classes.windowAnimation.setTime(1, keyFrameValue);
        svgoooManager.classes.windowAnimation.refresh();
    } else {
        svgoooManager.classes.windowAnimation.contextMenuEvaluate("duplicate", keyFrameLength);
        keyFrameLength = parseInt(keyFrameLength + 1);
        for (var i = 0; i < keyFrameLength; i++) {
            var val = svgoooManager.classes.windowAnimation.animation.keyframes.arr[i].time;
            var newVal = (val * currentDur) / currentTime;
            svgoooManager.classes.windowAnimation.setTime(i, newVal);
        }
        svgoooManager.classes.windowAnimation.animation.dur.value = currentTime;
        svgoooManager.classes.windowAnimation.setTime(keyFrameLength, 1);
        svgoooManager.classes.windowAnimation.refresh();

    }

}

$('.tree li').hover(
    function() { $(this).toggleClass("hovered"); }
)