/**
 *  @author		SVGANIMA
 *  @date		2022
 *  @copyright	GNU GPLv3
 *	@brief		"Abstract" class for editor tools - handles mouse events
 */
function tool() {
	this.target = null;
	this.lastEvent = null;
	this.downEvent = null;
}

tool.prototype.mouseDown = function(event) {
	this.lastEvent = event;
	this.downEvent = event;
}

tool.prototype.mouseUp = function(event) {
	this.target = null;
	this.lastEvent = null;
	this.downEvent = null;
}

tool.prototype.mouseClick = function(event) {}
	
tool.prototype.mouseDblClick = function(event) {}

tool.prototype.mouseMove = function(event) {
	if((event.button == 1 || event.buttons == 4) && this.lastEvent) {
		var dX = Math.round((this.lastEvent.clientX - event.clientX)/svg.zoom);
		var dY = Math.round((this.lastEvent.clientY - event.clientY)/svg.zoom);
		this.lastEvent = event;
		svg.moveView(dX, dY);
		return;
	}
}

tool.prototype.mouseContextMenu = function(event) {
	if(!svg || !(svg instanceof root)) { return; }
	
	if(!event.target.isChildOf(svgoooManager.named.left.container) && 
		!event.target.isChildOf(svgoooManager.named.right.container)) {
		popup.macroContextMenu({ 'target': event.target, 'x': event.clientX, 'y': event.clientY });
	}
	event.preventDefault ? event.preventDefault() : event.returnValue = false;
	return false;
}

tool.prototype.keyDown = function(event) {
	return true;
}

tool.prototype.keyUp = function(event) {
	return true;
}